---
type: api
title: Get instance types
description: Retrieves a list of all instance types.
url: https://www.elastic.co/docs/api/doc/cloud-enterprise/v3/operation/operation-get-instance-types
resource: https://www.elastic.co/docs/api/doc/cloud-enterprise/v3/operation/operation-get-instance-types
products:
  - Elastic Cloud Enterprise
---

# Get instance types

Authentication: required

## Paths

- `GET` `/stack/instance-types`

## Description

Retrieves a list of all instance types.

## Response

List of node types

`application/octet-stream`

Type: `object[]`

An array; each item has these fields:

- `instance_type` (enum)
  Instance type, the key for this resource
  Values: `elasticsearch`, `kibana`, `apm`, `integrations_server`, `appsearch`, `enterprise_search`
- `name` (string)
  Instance type name
- `description` (string)
  Instance type description
- `node_types` (object[])
  Supported node types
  - `node_type` (string)
    Node type, part of the key for this resource
  - `name` (string)
    Node type name
  - `description` (string)
    Node type description
  - `default_instance_configuration_id` (string)
    Id of the default instance configuration to use for this node type.
  - `mandatory` (boolean)
    Flag to specify a node type is mandatory in the corresponding cluster's plan
- `compatibility` (object[])
  Compatible versions
  - `version` (string)
    Compatible version, the key for this resource
  - `node_types` (object[])
    Supported node types for the version
    - `node_type` (string)
      Type of this node
    - `compatible_node_types` (string[])
      Compatible node types for the this node type
    - `capacity_constraints` (object)
      Specifies the maximum and minimum capacity constraints.
      - `min` (integer · format: int64)
        Min capacity
      - `max` (integer · format: int64)
        Max capacity
  - `capacity_constraints` (object)
    Specifies the maximum and minimum capacity constraints.
    - `min` (integer · format: int64)
      Min capacity
    - `max` (integer · format: int64)
      Max capacity
- `default_instance_configuration_id` (string)
  Id of the default instance configuration to use for this instance type.
## Code examples

#### curl

```curl
curl -X GET "${API_URL}/stack/instance-types" \
  -u "${USERNAME}:${PASSWORD}"
```

## Response examples

#### 200

`application/octet-stream`

